#include <stdint.h>
#include <fcitx/fcitx.h>
#include <fcitx-utils/utils.h>
#include <fcitx/instance.h>
#include <fcitx/addon.h>
#include <fcitx/module.h>


#ifndef __FCITX_MODULE_FCITX_DBUS_ADD_FUNCTION_H
#define __FCITX_MODULE_FCITX_DBUS_ADD_FUNCTION_H

#ifdef __cplusplus
extern "C" {
#endif

DEFINE_GET_ADDON("fcitx-dbus", _DBus_)

static void*
__fcitx_DBus_function_GetConnection(void *_self, FcitxModuleFunctionArg _args)
{
    FCITX_DEF_CAST_FROM_PTR(FcitxDBus*, __self, _self);
    FCITX_UNUSED(_args);
    FcitxDBus* self = __self;
    FCITX_UNUSED(self);
    DBusConnection* res = ((self)->conn);
    FCITX_RETURN_AS_PTR(DBusConnection*, res);
}

static void*
__fcitx_DBus_function_GetPrivConnection(void *_self, FcitxModuleFunctionArg _args)
{
    FCITX_DEF_CAST_FROM_PTR(FcitxDBus*, __self, _self);
    FCITX_UNUSED(_args);
    FcitxDBus* self = __self;
    FCITX_UNUSED(self);
    DBusConnection* res = ((self)->privconn);
    FCITX_RETURN_AS_PTR(DBusConnection*, res);
}

static void
FcitxDBusAddFunctions(FcitxInstance *instance)
{
    int i;
    FcitxAddon *addon = Fcitx_DBus_GetAddon(instance);
    static const FcitxModuleFunction ____fcitx_DBus_addon_functions_table[] = {
        __fcitx_DBus_function_GetConnection,
        __fcitx_DBus_function_GetPrivConnection,
    };
    for (i = 0;i < 2;i++) {
        FcitxModuleAddFunction(addon, ____fcitx_DBus_addon_functions_table[i]);
    }
}

#ifdef __cplusplus
}
#endif

#endif
